#include "k_inc_hawk"

void MarkSet()
{
	object oPC = GetPartyLeader();
	location lTarget = GetLocation(oPC);

	CreateObject(OBJECT_TYPE_PLACEABLE,"markleave",lTarget);
	string message1 = "Marker is set.";
	SendMessageToPC(GetFirstPC(), message1);
	SetGlobalBoolean("Markerset", 1);
}

void RecallSet()
{
	object oPC = GetPartyLeader();
	location lTarget = GetLocation(oPC);

	CreateObject(OBJECT_TYPE_PLACEABLE,"markreturn", lTarget);
	string message2 = "Recall point is set.";
	SendMessageToPC(GetFirstPC(), message2);
	SetGlobalBoolean("Recallset", 1);
}

void PortalMark()
{
	object oPC = GetFirstPC();
	object oMarker = GetObjectByTag("markleave");
	if (GetIsObjectValid(oMarker))
	{
		int Count = 0;
		while(Count <= GetPartyMemberCount())
		{
			object oTeleport = GetPartyMemberByIndex(Count);
			if(!GetIsDead(oTeleport))
			{
		
				SetCommandable(1, oTeleport);
				AssignCommand(oTeleport, JumpToObject(oMarker));
			}

			Count++;
		}

		DestroyObject(oMarker, 0.2f, 1, 0.0f, 0);
//		I input these next two lines of code in for testing purposes. ignore them.

//		string message3 = "Marker is destroyed.";
//		SendMessageToPC(GetFirstPC(), message3);
		SetGlobalBoolean("Markerset", 0);
	}
}

void PortalRecall()
{
	object oPC = GetFirstPC();
	object oRecall = GetObjectByTag("markreturn");
	if (GetIsObjectValid(oRecall))
	{
		int Count = 0;
		while(Count <= GetPartyMemberCount())
		{
			object oTeleport = GetPartyMemberByIndex(Count);
			if(!GetIsDead(oTeleport))
			{
				SetCommandable(1, oTeleport);
				AssignCommand(oTeleport, JumpToObject(oRecall));
			}
			
			Count++;
		}
		DestroyObject(oRecall, 0.2f, 1, 0.0f, 0);
//		I input these next two lines of code in for testing purposes. ignore them.

//		string message4 = "Recall point is destroyed.";
//		SendMessageToPC(GetFirstPC(), message4);
		SetGlobalBoolean("Recallset", 0);
	}
}

//Hopefully these next two functions will allow for module warping


//You can use this function if you want. All it does is set the last module for later use,
//though you could modify the style if you chose to do so. If it isn't broke, though,
//then why fix it?

void SetLastModule()
{
	if(GetModuleName() == "003EBO")
	{
		SetGlobalNumber("Module", 0);
	}
	if(GetModuleName() == "201TEL")
	{
		SetGlobalNumber("Module", 10);
	}
	if(GetModuleName() == "202TEL")
	{
		SetGlobalNumber("Module", 11);
	}
	if(GetModuleName() == "203TEL")
	{
		SetGlobalNumber("Module", 12);
	}
	if(GetModuleName() == "204TEL")
	{
		SetGlobalNumber("Module", 13);
	}
	if(GetModuleName() == "207TEL")
	{
		SetGlobalNumber("Module", 14);
	}
	if(GetModuleName() == "208TEL")
	{
		SetGlobalNumber("Module", 15);
	}
	if(GetModuleName() == "209TEL")
	{
		SetGlobalNumber("Module", 16);
	}
	if(GetModuleName() == "301NAR")
	{
		SetGlobalNumber("Module", 20);
	}
	if(GetModuleName() == "302NAR")
	{
		SetGlobalNumber("Module", 21);
	}
	if(GetModuleName() == "303NAR")
	{
		SetGlobalNumber("Module", 22);
	}
	if(GetModuleName() == "401DXN")
	{
		SetGlobalNumber("Module", 30);
	}
	if(GetModuleName() == "402DXN")
	{
		SetGlobalNumber("Module", 31);
	}
	if(GetModuleName() == "403DXN")
	{
		SetGlobalNumber("Module", 32);
	}
	if(GetModuleName() == "404DXN")
	{
		SetGlobalNumber("Module", 33);
	}
	if(GetModuleName() == "501OND")
	{
		SetGlobalNumber("Module", 40);
	}
	if(GetModuleName() == "502OND")
	{
		SetGlobalNumber("Module", 41);
	}
	if(GetModuleName() == "503OND")
	{
		SetGlobalNumber("Module", 42);
	}
	if(GetModuleName() == "512OND")
	{
		SetGlobalNumber("Module", 43);
	}
	if(GetModuleName() == "601DAN")
	{
		SetGlobalNumber("Module", 50);
	}
	if(GetModuleName() == "602DAN")
	{
		SetGlobalNumber("Module", 51);
	}
	if(GetModuleName() == "604DAN")
	{
		SetGlobalNumber("Module", 52);
	}
	if(GetModuleName() == "605DAN")
	{
		SetGlobalNumber("Module", 53);
	}
	if(GetModuleName() == "610DAN")
	{
		SetGlobalNumber("Module", 54);
	}
	if(GetModuleName() == "701KOR")
	{
		SetGlobalNumber("Module", 60);
	}
	if(GetModuleName() == "710KOR")
	{
		SetGlobalNumber("Module", 61);
	}
	if(GetModuleName() == "711KOR")
	{
		SetGlobalNumber("Module", 62);
	}

	SetGlobalBoolean("Moduleset", 1);
	string Global = "Last module was: " + IntToString(GetGlobalNumber("Module"));
	SendMessageToPC(GetFirstPC(), Global);
}

//This one is somewhat more complicated to read if you aren't used to digging through
//Bioware's scripts. :|
//A lot of repetitve code, so JCarter on Lucasforums won't like it (How would you do it, JC?),
//but it will simply start you off at the module set by the SetLastModule() function.
//I'm afraid I couldn't make it work with the four functions above the SetLastModule() function, otherwise //I'd have it start you off at a Mark or Recall spot...

void WarpToLastModule()
{
	if(GetGlobalNumber("K_CURRENT_PLANET") == 10)
	{
		switch(GetGlobalNumber("Module"))
		{
		case 0:
		{
			SetLastModule();
			if(GetModuleName() != "003EBO")
			{
				StartNewModule("003EBO");
			}
		}
		break;
		case 10:
		{
			SetLastModule();
			if(GetModuleName() != "201TEL")
			{
				StartNewModule("201TEL");
			}
		}

		break;
		case 11:
		{
			SetLastModule();
			if(GetModuleName() != "202TEL")
			{
				StartNewModule("202TEL");
			}
		}
		break;
		case 12:
		{
			SetLastModule();
			if(GetModuleName() != "203TEL")
			{
				StartNewModule("203TEL");
			}
		}
		break;
		case 13:
		{
			SetLastModule();
			if(GetModuleName() != "204TEL")
			{
				StartNewModule("204TEL");
			}
		}
		break;
		case 14:
		{
			SetLastModule();
			if(GetModuleName() != "207TEL")
			{
				StartNewModule("207TEL");
			}
		}
		break;
		case 15:
		{
			SetLastModule();
			if(GetModuleName() != "208TEL")
			{
				StartNewModule("208TEL");
			}
		}
		break;
		case 16:
		{
			SetLastModule();
			if(GetModuleName() != "209TEL")
			{
				StartNewModule("209TEL");
			}
		}
		break;
		}
	}

	if(GetGlobalNumber("K_CURRENT_PLANET") == 6)
	{
		switch(GetGlobalNumber("Module"))
		{
		case 0:
		{
			SetLastModule();
			if(GetModuleName() != "003EBO")
			{
				StartNewModule("003EBO");
			}
		}
		break;
		case 20:
		{
			SetLastModule();
			if(GetModuleName() != "301NAR")
			{
				StartNewModule("301NAR");
			}
		}
		break;
		case 21:
		{
			SetLastModule();
			if(GetModuleName() != "302NAR")
			{
				StartNewModule("302NAR");
			}
		}
		break;
		case 22:
		{
			SetLastModule();
			if(GetModuleName() != "303NAR")
			{
				StartNewModule("303NAR");
			}
		}
		break;
		}
	}

	if(GetGlobalNumber("K_CURRENT_PLANET") == 1)
	{
		switch(GetGlobalNumber("Module"))
		{
		case 0:
		{
			SetLastModule();
			if(GetModuleName() != "003EBO")
			{
				StartNewModule("003EBO");
			}
		}
		break;
		case 30:
		{
			SetLastModule();
			if(GetModuleName() != "401DXN")
			{
				StartNewModule("401DXN");
			}
		}
		break;
		case 31:
		{
			SetLastModule();
			if(GetModuleName() != "402DXN")
			{
				StartNewModule("402DXN");
			}
		}
		break;
		case 32:
		{
			SetLastModule();
			if(GetModuleName() != "403DXN")
			{
				StartNewModule("403DXN");
			}
		}
		break;
		case 33:
		{
			SetLastModule();
			if(GetModuleName() != "404DXN")
			{
				StartNewModule("404DXN");
			}
		}
		break;
		}
	}

	if(GetGlobalNumber("K_CURRENT_PLANET") == 7)
	{
		switch(GetGlobalNumber("Module"))
		{
		case 40:
		{
			SetLastModule();
			if(GetModuleName() != "501OND")
			{
				StartNewModule("501OND");
			}
		}
		break;
		case 41:
		{
			SetLastModule();
			if(GetModuleName() != "502OND")
			{
				StartNewModule("502OND");
			}
		}
		break;
		case 42:
		{
			SetLastModule();
			if(GetModuleName() != "503OND")
			{
				StartNewModule("503OND");
			}
		}
		break;
		case 43:
		{
			SetLastModule();
			if(GetModuleName() != "512OND")
			{
				StartNewModule("512OND");
			}
		}
		break;
		}
	}

	if(GetGlobalNumber("K_CURRENT_PLANET") == 0)
	{
		switch(GetGlobalNumber("Module"))
		{
		case 0:
		{
			SetLastModule();
			if(GetModuleName() != "003EBO")
			{
				StartNewModule("003EBO");
			}
		}
		break;
		case 50:
		{
			SetLastModule();
			if(GetModuleName() != "601DAN")
			{
				StartNewModule("601DAN");
			}
		}
		break;
		case 51:
		{
			SetLastModule();
			if(GetModuleName() != "602DAN")
			{
				StartNewModule("602DAN");
			}
		}
		break;
		case 52:
		{
			SetLastModule();
			if(GetModuleName() != "604DAN")
			{
				StartNewModule("604DAN");
			}
		}
		break;
		case 53:
		{
			SetLastModule();
			if(GetModuleName() != "605DAN")
			{
				StartNewModule("605DAN");
			}
		}
		break;
		case 54:
		{
			SetLastModule();
			if(GetModuleName() != "610DAN")
			{
				StartNewModule("610DAN");
			}
		}
		break;
		}
	}

	if(GetGlobalNumber("K_CURRENT_PLANET") == 3)
	{
		switch(GetGlobalNumber("Module"))
		{
		case 0:
		{
			SetLastModule();
			if(GetModuleName() != "003EBO")
			{
				StartNewModule("003EBO");
			}
		}
		break;
		case 60:
		{
			SetLastModule();
			if(GetModuleName() != "701KOR")
			{
				StartNewModule("701KOR");
			}
		}
		break;
		case 61:
		{
			SetLastModule();
			if(GetModuleName() != "710KOR")
			{
				StartNewModule("710KOR");
			}
		}
		break;
		case 62:
		{
			SetLastModule();
			if(GetModuleName() != "711KOR")
			{
				StartNewModule("711KOR");
			}
		}
		break;
		}
	}

	if(GetModuleName() == "003EBO")
	{
		int Planet = GetGlobalNumber("003EBO_BACKGROUND");
		string Planet1 = "You're on: " + IntToString(Planet);
		SendMessageToPC(GetFirstPC(), Planet1);
		if(Planet == 1)
		{
			switch(GetGlobalNumber("Module"))
			{
			case 10:
			{
				SetLastModule();
				if(GetModuleName() != "201TEL")
				{
					StartNewModule("201TEL");
				}
			}
			case 11:
			{
				SetLastModule();
				if(GetModuleName() != "202TEL")
				{
					StartNewModule("202TEL");
				}
			}
			case 12:
			{
				SetLastModule();
				if(GetModuleName() != "203TEL")
				{
					StartNewModule("203TEL");
				}
			}
			case 13:
			{
				SetLastModule();
				if(GetModuleName() != "204TEL")
				{
					StartNewModule("204TEL");
				}
			}
			case 14:
			{
				SetLastModule();
				if(GetModuleName() != "207TEL")
				{
					StartNewModule("207TEL");
				}
			}
			case 15:
			{
				SetLastModule();
				if(GetModuleName() != "208TEL")
				{
					StartNewModule("208TEL");
				}
			}
			case 16:
			{
				SetLastModule();
				if(GetModuleName() != "209TEL")
				{
					StartNewModule("209TEL");
				}
			}
			}
		}
		if(Planet == 3)
		{
			switch(GetGlobalNumber("Module"))
			{
			case 20:
			{
				SetLastModule();
				if(GetModuleName() != "301NAR")
				{
					StartNewModule("301NAR");
				}
			}
			case 21:
			{
				SetLastModule();
				if(GetModuleName() != "302NAR")
				{
					StartNewModule("302NAR");
				}
			}
			case 22:
			{
				SetLastModule();
				if(GetModuleName() != "303NAR")
				{
					StartNewModule("303NAR");
				}
			}
			}
		}
		if(Planet == 4)
		{
			switch(GetGlobalNumber("Module"))
			{
			case 30:
			{
				SetLastModule();
				if(GetModuleName() != "401DXN")
				{
					StartNewModule("401DXN");
				}
			}
			case 31:
			{
				SetLastModule();
				if(GetModuleName() != "402DXN")
				{
					StartNewModule("402DXN");
				}
			}
			case 32:
			{
				SetLastModule();
				if(GetModuleName() != "403DXN")
				{
					StartNewModule("403DXN");
				}
			}
			case 33:
			{
				SetLastModule();
				if(GetModuleName() != "404DXN")
				{
					StartNewModule("404DXN");
				}
			}
			}
		}
		if(Planet == 5)
		{
			switch(GetGlobalNumber("Module"))
			{
			case 50:
			{
				SetLastModule();
				if(GetModuleName() != "601DAN")
				{
					StartNewModule("601DAN");
				}
			}
			case 51:
			{
				SetLastModule();
				if(GetModuleName() != "602DAN")
				{
					StartNewModule("602DAN");
				}
			}
			case 52:
			{
				SetLastModule();
				if(GetModuleName() != "604DAN")
				{
					StartNewModule("604DAN");
				}
			}
			case 53:
			{
				SetLastModule();
				if(GetModuleName() != "605DAN")
				{
					StartNewModule("605DAN");
				}
			}
			case 54:
			{
				SetLastModule();
				if(GetModuleName() != "610DAN")
				{
					StartNewModule("610DAN");
				}
			}
			}
		}
		if(Planet == 6)
		{
			switch(GetGlobalNumber("Module"))
			{
			case 60:
			{
				SetLastModule();
				if(GetModuleName() != "701KOR")
				{
					StartNewModule("701KOR");
				}
			}
			case 61:
			{
				SetLastModule();
				if(GetModuleName() != "710KOR")
				{
					StartNewModule("710KOR");
				}
			}
			case 62:
			{
				SetLastModule();
				if(GetModuleName() != "711KOR")
				{
					StartNewModule("711KOR");
				}
			}
			}
		}
	}
}